=begin
#KORONA.entry API v1

#Our api provides access to our entry services

The version of the OpenAPI document: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.0

=end

require 'date'

module KoronaEntryClient
  # Represents a tickte log entry, f.e. created by update, check or access.
  class TicketEntryLog
    # Objects ID.
    attr_accessor :id

    # Short comment for this action.
    attr_accessor :comment

    attr_accessor :ticket

    attr_accessor :ticket_entry

    # Identification of action type.
    attr_accessor :log_type

    # Identification of response type.
    attr_accessor :response

    # Time of action.
    attr_accessor :time

    # Number of the organizational unit concerned.
    attr_accessor :organizational_unit_number

    # Client concerned.
    attr_accessor :client

    # Number of uses if its an entry action.
    attr_accessor :number_of_uses

    # Identification of commit type.
    attr_accessor :commit_type

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'comment' => :'comment',
        :'ticket' => :'ticket',
        :'ticket_entry' => :'ticketEntry',
        :'log_type' => :'logType',
        :'response' => :'response',
        :'time' => :'time',
        :'organizational_unit_number' => :'organizationalUnitNumber',
        :'client' => :'client',
        :'number_of_uses' => :'numberOfUses',
        :'commit_type' => :'commitType'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'id' => :'Integer',
        :'comment' => :'String',
        :'ticket' => :'ModelReference',
        :'ticket_entry' => :'ModelReference',
        :'log_type' => :'String',
        :'response' => :'String',
        :'time' => :'DateTime',
        :'organizational_unit_number' => :'String',
        :'client' => :'String',
        :'number_of_uses' => :'Integer',
        :'commit_type' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `KoronaEntryClient::TicketEntryLog` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `KoronaEntryClient::TicketEntryLog`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.key?(:'comment')
        self.comment = attributes[:'comment']
      end

      if attributes.key?(:'ticket')
        self.ticket = attributes[:'ticket']
      end

      if attributes.key?(:'ticket_entry')
        self.ticket_entry = attributes[:'ticket_entry']
      end

      if attributes.key?(:'log_type')
        self.log_type = attributes[:'log_type']
      end

      if attributes.key?(:'response')
        self.response = attributes[:'response']
      end

      if attributes.key?(:'time')
        self.time = attributes[:'time']
      end

      if attributes.key?(:'organizational_unit_number')
        self.organizational_unit_number = attributes[:'organizational_unit_number']
      end

      if attributes.key?(:'client')
        self.client = attributes[:'client']
      end

      if attributes.key?(:'number_of_uses')
        self.number_of_uses = attributes[:'number_of_uses']
      end

      if attributes.key?(:'commit_type')
        self.commit_type = attributes[:'commit_type']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      log_type_validator = EnumAttributeValidator.new('String', ["CREATE", "UPDATE", "EXTEND", "VALIDATE", "PREPARE_ENTRY", "COMMIT_ENTRY"])
      return false unless log_type_validator.valid?(@log_type)
      response_validator = EnumAttributeValidator.new('String', ["BEFORETIME", "DENIED", "DOESNTEXIST", "EXHAUSTED", "INVALID", "LOCKED", "SUSPENDED", "TIMEUP", "TIME_QUOTA_OVERDRAWN", "SUCCESS"])
      return false unless response_validator.valid?(@response)
      commit_type_validator = EnumAttributeValidator.new('String', ["ACCESS", "EXIT"])
      return false unless commit_type_validator.valid?(@commit_type)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] log_type Object to be assigned
    def log_type=(log_type)
      validator = EnumAttributeValidator.new('String', ["CREATE", "UPDATE", "EXTEND", "VALIDATE", "PREPARE_ENTRY", "COMMIT_ENTRY"])
      unless validator.valid?(log_type)
        fail ArgumentError, "invalid value for \"log_type\", must be one of #{validator.allowable_values}."
      end
      @log_type = log_type
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] response Object to be assigned
    def response=(response)
      validator = EnumAttributeValidator.new('String', ["BEFORETIME", "DENIED", "DOESNTEXIST", "EXHAUSTED", "INVALID", "LOCKED", "SUSPENDED", "TIMEUP", "TIME_QUOTA_OVERDRAWN", "SUCCESS"])
      unless validator.valid?(response)
        fail ArgumentError, "invalid value for \"response\", must be one of #{validator.allowable_values}."
      end
      @response = response
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] commit_type Object to be assigned
    def commit_type=(commit_type)
      validator = EnumAttributeValidator.new('String', ["ACCESS", "EXIT"])
      unless validator.valid?(commit_type)
        fail ArgumentError, "invalid value for \"commit_type\", must be one of #{validator.allowable_values}."
      end
      @commit_type = commit_type
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          comment == o.comment &&
          ticket == o.ticket &&
          ticket_entry == o.ticket_entry &&
          log_type == o.log_type &&
          response == o.response &&
          time == o.time &&
          organizational_unit_number == o.organizational_unit_number &&
          client == o.client &&
          number_of_uses == o.number_of_uses &&
          commit_type == o.commit_type
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [id, comment, ticket, ticket_entry, log_type, response, time, organizational_unit_number, client, number_of_uses, commit_type].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        KoronaEntryClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
